(* $Id: clruntime.ml,v 1.3 2014/03/04 17:25:28 deraugla Exp $ *)
(* Copyright (c) 2002 INRIA *)

let format_int _ = failwith "not implemented Clruntime.format_int";;
let format_float _ = failwith "not implemented Clruntime.format_float";;

external acos_float : float -> float = "caml_acos_float" "acos" "float";;
external asin_float : float -> float = "caml_asin_float" "asin" "float";;
external atan_float : float -> float = "caml_atan_float" "atan" "float";;
external atan2_float :
  float -> float -> float = "caml_atan2_float" "atan2" "float";;
external blit_string :
  string -> int -> string -> int -> int -> unit = "caml_blit_string" "noalloc"
;;
external compare : 'a -> 'a -> int = "caml_compare";;
external compare_strings : string -> string -> int = "caml_compare";;
external cos_float : float -> float = "caml_cos_float" "cos" "float";;
external cosh_float : float -> float = "caml_cosh_float" "cosh" "float";;
external create_string : int -> string = "caml_create_string";;
external equal : 'a -> 'a -> bool = "%equal";;
external exp_float : float -> float = "caml_exp_float" "exp" "float";;
external fill_string :
  string -> int -> int -> char -> unit = "caml_fill_string" "noalloc";;
external float_of_int : int -> float = "%floatofint";;
external get_nth_char : string -> int -> char = "%string_safe_get";;
external greaterequal : 'a -> 'a -> bool = "%greaterequal";;
external greaterthan : 'a -> 'a -> bool = "%greaterthan";;
external identity : 'a -> 'b = "%identity";;
external int_of_float : float -> int = "%intoffloat";;
external int_of_string : string -> int = "caml_int_of_string";;
external is_printable : char -> bool = "caml_is_printable";;
external lessequal : 'a -> 'a -> bool = "%lessequal";;
external lessthan : 'a -> 'a -> bool = "%lessthan";;
external log_float : float -> float = "caml_log_float" "log" "float";;
external log10_float : float -> float = "caml_log10_float" "log10" "float";;
external notequal : 'a -> 'a -> bool = "%notequal";;
external power_float : float -> float -> float = "caml_power_float" "pow"
  "float";;
external pred : int -> int = "%predint";;
external prefix div : int -> int -> int = "%divint";;
external prefix mod : int -> int -> int = "%modint";;
external prefix not : bool -> bool = "%boolnot";;
external prefix == : 'a -> 'a -> bool = "%eq";;
external prefix != : 'a -> 'a -> bool = "%noteq";;
external prefix "and" : int -> int -> int = "%andint";;
external prefix "or" : int -> int -> int = "%orint";;
external prefix "xor" : int -> int -> int = "%xorint";;
external prefix "~int" : int -> int = "%negint";;
external prefix "+int" : int -> int -> int = "%addint";;
external prefix "-int" : int -> int -> int = "%subint";;
external prefix "*int" : int -> int -> int = "%mulint";;
external prefix "/int" : int -> int -> int = "%divint";;
external prefix "=int" : int -> int -> bool = "%eq";;
external prefix ">=int" : int -> int -> bool = "%greaterequal";;
external prefix ">int" : int -> int -> bool = "%greaterthan";;
external prefix "<=int" : int -> int -> bool = "%lessequal";;
external prefix "<int" : int -> int -> bool = "%lessthan";;
external prefix "<>int" : int -> int -> bool = "%notequal";;
external prefix "=string" : string -> string -> bool = "%eq";;
external prefix ">=string" : string -> string -> bool = "%greaterequal";;
external prefix ">string" : string -> string -> bool = "%greaterthan";;
external prefix "<=string" : string -> string -> bool = "%lessequal";;
external prefix "<string" : string -> string -> bool = "%lessthan";;
external prefix "<>string" : string -> string -> bool = "%notequal";;
external prefix "~float" : float -> float = "%negfloat";;
external prefix "+float" : float -> float -> float = "%addfloat";;
external prefix "-float" : float -> float -> float = "%subfloat";;
external prefix "*float" : float -> float -> float = "%mulfloat";;
external prefix "/" : float -> float -> float = "%divfloat";;
external prefix "=float" : float -> float -> bool = "%eq";;
external prefix "<>float" : float -> float -> bool = "%notequal";;
external prefix ">=float" : float -> float -> bool = "%greaterequal";;
external prefix ">float" : float -> float -> bool = "%greaterthan";;
external prefix "<=float" : float -> float -> bool = "%lessequal";;
external prefix "<float" : float -> float -> bool = "%lessthan";;
external raise : exn -> 'a = "%raise";;
external sequand : bool -> bool -> bool = "%sequand";;
external sequor : bool -> bool -> bool = "%sequor";;
external set_nth_char : string -> int -> char -> unit = "%string_safe_set";;
external shift_left : int -> int -> int = "%lslint";;
external shift_right_unsigned : int -> int -> int = "%lsrint";;
external shift_right_signed : int -> int -> int = "%asrint";;
external sin_float : float -> float = "caml_sin_float" "sin" "float";;
external sinh_float : float -> float = "caml_sinh_float" "sinh" "float";;
external sqrt_float : float -> float = "caml_sqrt_float" "sqrt" "float";;
external string_length : string -> int = "%string_length";;
external succ : int -> int = "%succint";;
external tan_float : float -> float = "caml_tan_float" "tan" "float";;
external tanh_float : float -> float = "caml_tanh_float" "tanh" "float";;

external ceil_float : float -> float = "caml_ceil_float" "ceil" "float";;
external floor_float : float -> float = "caml_floor_float" "floor" "float";;
external fabs_float : float -> float = "%absfloat";;
external fmod_float : float -> float -> float = "caml_fmod_float" "fmod"
  "float";;
external frexp_float : float -> float * int = "caml_frexp_float";;
external ldexp_float : float -> int -> float = "caml_ldexp_float";;
external modf_float : float -> float * float = "caml_modf_float";;
external float_of_string : string -> float = "caml_float_of_string";;

external vect_length : 'a array -> int = "%array_length";;
external get_vect_item : 'a array -> int -> 'a = "%array_safe_get";;
external set_vect_item : 'a array -> int -> 'a -> unit = "%array_safe_set";;
external make_vect : int -> 'a -> 'a array = "caml_make_vect";;

let open_descriptor _ = failwith "not implemented Clruntime.open_descriptor";;
external flush : out_channel -> unit = "caml_ml_flush";;

external output_char : out_channel -> 'a -> unit = "caml_ml_output_char";;
external channel_size : 'a -> int = "caml_ml_channel_size";;

external output_int : out_channel -> int -> unit = "caml_ml_output_int";;
let extern_val = output_value;;
let extern_compact_val = output_value;;
external seek_out : out_channel -> int -> unit = "caml_ml_seek_out";;
external pos_out : out_channel -> int = "caml_ml_pos_out";;
external close_out : out_channel -> unit = "caml_ml_close_channel";;

external input_char : in_channel -> 'a = "caml_ml_input_char";;
external input_int : in_channel -> int = "caml_ml_input_int";;
external intern_val : in_channel -> 'a = "caml_input_value";;
external seek_in : in_channel -> int -> unit = "caml_ml_seek_in";;
external pos_in : in_channel -> int = "caml_ml_pos_in";;
external close_in : in_channel -> unit = "caml_ml_close_channel";;

external field0 : 'a * 'b -> 'a = "%field0";;
external field1 : 'a * 'b -> 'b = "%field1";;

let get_next_char _ = failwith "not implemented Clruntime.get_next_char";;

let gc_stat () = failwith "not implemented Clruntime.gc_stat";;
let gc_get () = failwith "not implemented Clruntime.gc_get";;
let gc_set _ = failwith "not implemented Clruntime.gc_set";;
